#pragma once

#include <lcrash/types.h>

/**
 * Initialize kernel heap, returns 0 on success
 */
int KernelHeapInitialize();

/**
 * Allocate memory
 */
void* KernelHeapAlloc(u32 Size, u32 Align, u32 Flags);

/// Flag for KernelHeapAlloc: Zero memory
#define KHA_ZERO 1

/**
 * Free memory
 */
void KernelHeapFree(void* Address);
